'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var async = require('@shopify/async');
var types = require('./types.js');
var hooks = require('./hooks.js');
var Prefetcher = require('./Prefetcher.js');
var PrefetchRoute = require('./PrefetchRoute.js');
var component = require('./component.js');
var provider = require('./provider.js');
var assets = require('./context/assets.js');
var prefetch = require('./context/prefetch.js');



Object.defineProperty(exports, 'DeferTiming', {
	enumerable: true,
	get: function () { return async.DeferTiming; }
});
Object.defineProperty(exports, 'AssetTiming', {
	enumerable: true,
	get: function () { return types.AssetTiming; }
});
exports.useAsync = hooks.useAsync;
exports.useAsyncAsset = hooks.useAsyncAsset;
exports.useKeepFresh = hooks.useKeepFresh;
exports.usePrefetch = hooks.usePrefetch;
exports.usePreload = hooks.usePreload;
exports.Prefetcher = Prefetcher.Prefetcher;
exports.PrefetchRoute = PrefetchRoute.PrefetchRoute;
exports.createAsyncComponent = component.createAsyncComponent;
exports.createAsyncContext = provider.createAsyncContext;
exports.AsyncAssetContext = assets.AsyncAssetContext;
exports.AsyncAssetManager = assets.AsyncAssetManager;
exports.PrefetchContext = prefetch.PrefetchContext;
exports.PrefetchManager = prefetch.PrefetchManager;
