import React from 'react';
import { PrefetchContext } from './context/prefetch.mjs';

class ConnectedPrefetchRoute extends React.Component {
  constructor(...args) {
    super(...args);
    this.unregister = void 0;
  }

  componentDidMount() {
    const {
      manager,
      path,
      render
    } = this.props;
    this.unregister = manager.register({
      path,
      render
    });
  }

  componentWillUnmount() {
    if (this.unregister) {
      this.unregister();
    }
  }

  render() {
    return null;
  }

}

function PrefetchRoute(props) {
  return /*#__PURE__*/React.createElement(PrefetchContext.Consumer, null, manager => /*#__PURE__*/React.createElement(ConnectedPrefetchRoute, Object.assign({
    manager: manager
  }, props)));
}

export { PrefetchRoute };
